; Release 0.14

;---------------------------------------;
        macro   loop llab               ;
        dec     cx                      ;
        jne short llab                  ;
        endm                            ;
;---------------------------------------;

Ver     equ     "0.04"                  ; ⫠稪
Date    equ     ??date                  ; 樨
sPSP    equ     08h                     ; dPSP - GDTbeg
sCode   equ     10h                     ; dCode - GDTbeg
sData   equ     18h                     ; dData - GDTbeg
sStack  equ     20h                     ; dStack - GDTbeg
sVideo  equ     28h                     ; dVideo - GDTbeg
sGraph  equ     30h                     ; dGraph - GDTbeg
sTSS0   equ     38h                     ; dTSS0 - GDTbeg
sTSSdos equ     43h                     ; dTSSdos - GDTbeg + 3
sTSSv86 equ     4Bh                     ; dTSSv86 - GDTbeg + 3
sConv   equ     50h                     ; dConv - GDTbeg
sLDT0   equ     58h                     ; dLDT0 - GDTbeg
sLDT3   equ     63h                     ; dLDT3 - GDTbeg + 3
sTSS    equ     68h                     ; dTSSv88 - GDTbeg
sPSP93  equ     70h                     ; dPSP93 - GDTbeg

DBSIZE  EQU     64                      ; Debugger's size in kilobytes

EXT     equ     10h                     ;
SHIFT   equ     20h                     ;
CTRL    equ     40h                     ;
ALT     equ     80h                     ;
CAPS    equ     04h                     ;
NUM     equ     02h                     ;
SCROLL  equ     01h                     ;

BIOS_COL        equ     50h             ;
BIOS_ROW        equ     51h             ;
BIOS_WIDTH      equ     4Ah             ;
BIOS_HEIGHT     equ     84h             ;

TERM_CS equ     0Ch                     ;
TERM_IP equ     0Ah                     ;

        macro   delay                   ;
        jmp     $+2                     ;
        jmp     $+2                     ;
        jmp     $+2                     ;
        endm                            ;

        struc   desc                    ;
limit   dw      0                       ;
baseL   dw      0                       ;
baseM   db      0                       ;
access  db      0                       ;
acclim  db      0                       ;
baseH   db      0                       ;
        ends                            ;

        macro   setAddr dOffs
        add     [dOffs.baseL],ax        ;
        adc     [dOffs.baseM],dl        ;
        adc     [dOffs.baseH],dh        ;
        endm

        struc   gate
offsL   dw      0                       ;
sel     dw      sCode                   ;
count   db      0                       ;
access  db      8Eh                     ;
offsH   dw      0                       ;
        ends

        struc   tss                     ;
back    dw      0                       ; Backward reference
        dw      0                       ;
esp0    dd      0FFFEh                  ;
ss0     dw      sStack                  ;
        dw      0                       ;
esp1    dd      0FFFEh                  ;
ss1     dw      sStack                  ;
        dw      0                       ;
esp2    dd      0FFFEh                  ;
ss2     dw      sStack                  ;
        dw      0                       ;
_cr3    dd      0                       ;
_eip    dd      0                       ;
_eflags dd      2                       ;
_eax    dd      0                       ;
_ecx    dd      0                       ;
_edx    dd      0                       ;
_ebx    dd      0                       ;
_esp    dd      0                       ;
_ebp    dd      0                       ;
_esi    dd      0                       ;
_edi    dd      0                       ;
_es     dw      sData                   ;
        dw      0                       ;
_cs     dw      sCode                   ;
        dw      0                       ;
_ss     dw      sStack                  ;
        dw      0                       ;
_ds     dw      sData                   ;
        dw      0                       ;
_fs     dw      sData                   ;
        dw      0                       ;
_gs     dw      sData                   ;
        dw      0                       ;
_ldt    dw      sLDT0                   ;
        dw      0                       ;
        dw      0                       ;
iomap   dw      104                     ;
        ends                            ;

        struc   dos_regs
_ax     dw      0
_bx     dw      0
_cx     dw      0
_dx     dw      0
_si     dw      0
_di     dw      0
_bp     dw      0
_sp     dw      300h
_ss     dw      0
_ds     dw      0
_es     dw      0
_flags  dw      0
        ends

        struc   epb
evir    dw      0
comlin  dd      ?
fcb1    dd      ?
fcb2    dd      ?
sssp    dd      ?
csip    dd      ?
        ends

        Global  @STACK@ : proc

        Global  TSSv86  : tss
        Global  trace   : byte
        Global  DOSRegs : dos_regs
        Global  realCS  : word
        Global  retstk  : dword : 10
        Global  level   : word
        Global  child   : epb
        Global  exitflg : byte
        Global  resd    : byte
        Global  oldvecs : dword : 256

        Global  getkey  : proc
        Global  kbhit   : proc
        Global  IRQ0    : proc
        Global  IRQ1    : proc
        Global  IRQ2    : proc
        Global  IRQ3    : proc
        Global  IRQ4    : proc
        Global  IRQ5    : proc
        Global  IRQ6    : proc
        Global  IRQ7    : proc
        Global  IRQ8    : proc
        Global  IRQ9    : proc
        Global  IRQ10   : proc
        Global  IRQ11   : proc
        Global  IRQ12   : proc
        Global  IRQ13   : proc
        Global  IRQ14   : proc
        Global  IRQ15   : proc
        Global  INTn    : proc
        Global  MasterEOT : proc
        Global  SlaveEOT: proc
        Global  Exc0    : proc
        Global  Exc1    : proc
        Global  Exc2    : proc
        Global  Exc3    : proc
        Global  Exc4    : proc
        Global  Exc5    : proc
        Global  Exc6    : proc
        Global  Exc7    : proc
        Global  Exc8    : proc
        Global  Exc9    : proc
        Global  Exc10   : proc
        Global  Exc11   : proc
        Global  Exc12   : proc
        Global  Exc13   : proc
        Global  Exc14   : proc
        Global  Exc15   : proc
        Global  Exc16   : proc
        Global  Exc17_31: proc
        Global  ExcNN   : proc

        Global  Uninstall       : proc
        Global  ReturnReal      : proc
        Global  ReturnDOS       : proc
        Global  RestoreVectors  : proc
        Global  UserExec        : proc
        Global  Reload          : proc
        Global  WriteCMOS       : proc

        Global  extsize : word
        Global  CUR_COL : byte
        Global  CUR_ROW : byte
        Global  MAX_COL : byte
        Global  MAX_ROW : byte

        Global  DumpRegs        : proc
        Global  Dump386Regs     : proc
        Global  DumpStack       : proc
        Global  DumpTSS         : proc
;       Global  DoSomething: proc
        Global  PrintChar       : proc
        Global  PrintAX         : proc
        Global  NewLine         : proc

        Global  DOS     : proc

        Global  SetBreak        : proc
        Global  EnableBreak     : proc
        Global  DisableBreak    : proc

        Global  Master  : proc

        Global  draw_face: proc
        Global  comtxt  : byte
