;***************************************************************
;* Loader                                                      *
;* Programmed by ALI                                           *
;* Version 0.14                       Last revision:  9-Sep-93 *
;***************************************************************

DEBUG   = 1

;--------------------------- History ---------------------------
; Ver      Date          Who        Description
; 0.1      20-Feb-93     AlI        In the beginning
; 0.11     20-Aug-93     ALI        XMM Support added
; 0.12     21-Aug-93     ALI        A20 Line Control added
; 0.13      2-Sep-93     ALI        Fixed bug with exit code. Displaying
;                                   of 'restxt' has been added.
;                                   Temporary checking of video mode upon
;                                   exit added.
; 0.14      9-Sep-93     ALI        Support of non-standard text video
;                                   modes added.
;                                   Fixed bug with PICs, DG now don't
;                                   change PIC masks for user task.
;                                   While initialization DG correctly
;                                   shrinks the stack.
;---------------------------------------------------------------
; 0.15    14--96   CrazyMaX      ⠢ ਭ㤨⥫쭠 ⠭
;                                   03h ⥪. ०  室  ⪨
;                                   
Ideal                                   ;
NOSMART
P386                                    ;

include "defines.inc"                   ;
include "xmm.inc"                       ;
include "a20.inc"                       ;

extrn   Dos_flag        :dword          ;  䫠  
extrn   dos_adr         :dword          ;   
extrn   kbd_hrd         :proc           ; ᠬ. ࠡ. 
extrn   emul_6          :proc           ; ᠬ. ࠡ. 
global  DOS             :proc
global  _XMM_           :dword

        segment code word public use16 'CODE'
        assume  cs:code,ds:code

        org     100h

Start:  jmp     InitLoader

        dw      100h dup(0)             ; Stack
@STACK@:                                ;

; Here terminates the program
psp_addres dw   0                       ; PSP DeGlucker'a
psp_save   dw   0                       ;  PSP த⥫
deskr   dw      0                       ;९ XMS

ReturnDOS:                              ;
        call    RestoreVectors          ;
        call    ReturnReal              ;
FreeXMS:
        push    cs
        pop     ds
        mov     [byte exitflg],1     ;
        cmp     [word _XMM_+2],0
        je      RealExit
        mov     ah,7
        call    [_XMM_]                 ;஢ਫ A20
        cmp     al,1
        je      @@rd1
        mov     ah,5
        call    [_XMM_]                 ;ࠧ訫 
@@rd1:  mov     dx,[deskr]
        push    dx
        mov     ah,0dh
        call    [_XMM_]                 ;⯥ 
        pop     dx
        mov     ah,0ah
        call    [_XMM_]                 ;᢮ 
RealExit:
; This is a temporary code (*)
@@rd2:

        mov     dx, 3CEh                ;
        mov     al, 06h                 ;
        out     dx, al                  ;
        jmp     $+2                     ;
        inc     dx                      ;
        in      al, dx                  ;
        test    al, 01h                 ;
        jz      @@10                    ;

        mov     ax,0000011b
        int     10h                     ; Set text mode
@@10:   mov     al,36h                  ; ᨫ ⠩
        out     43h,al
        xor     al,al
        ror     bx,15
        out     40h,al
        ror     bx,15
        out     40h,al
;ࠧ᪨஢ 
        in      al,61h
        and     al,01111111b
        out     61h,al
        mov     al,0aeh                 ;
        out     64h,al
        mov     al,0f6h
        out     60h,al
        mov     ax,0305h
        mov     bx,3
        int     16h

        mov     ax,[psp_save]
        or      ax,ax
        je      exx
        mov     [016h],ax

exx:    mov     ah,1
        int     16h
        jz      exitt
        xor     ax,ax
        int     16h
        jmp     exx

exitt:  mov     ax,4C00h                ;
        int     21h                     ; Exit to DOS

; And here we release the part residing in conventional memory

Uninstall:                              ; We expect return address in DX:BX
        call    ReturnReal              ;
        push    dx                      ;
        push    bx                      ;
        mov     ax,[realCS]             ;
        mov     es,ax                   ;
        mov     ah,49h                  ;
        int     21h                     ;
;᢮ XMS

        mov     [byte es:RealExit],0c3h         ;ᠬ䨪  !!!
        call    FreeXMS

        retf                            ;

;++ PROTECTED
; Call DOS services from protected mode.
; This procedure doesn't provide any safety checks about parameters
; passing to DOS, so it isn't liable for any consequences.
; Entry:
;       all registers in DOSRegs structure
; Return:
;       all registers and flags in DOSRegs structure
;--

        proc    DOS                     ;

        pushad
        push    ds
        push    es

        mov     [word ss:TSS0._esp],sp  ; Save protected mode SP
        call    ReturnReal              ; Return to real mode
; Now we are in conventional memory
        mov     ax,[DOSRegs._ax]        ; Notice that the ReturnReal
        mov     bx,[DOSRegs._bx]        ; procedure does reload DS
        mov     cx,[DOSRegs._cx]        ; segment register with selector
        mov     dx,[DOSRegs._dx]        ; sData so we can get data
        mov     si,[DOSRegs._si]        ; which resides in extended memory
        mov     di,[DOSRegs._di]        ; Then we setup registers
        mov     bp,[DOSRegs._bp]        ; and call DOS which does all
        mov     ds,[DOSRegs._ds]        ; dirty work.
        mov     es,[DOSRegs._es]        ; We don't care about safety
        int     21h                     ;
        mov     [cs:DOSRegs._ax],ax     ; This is REALly cool MODE and
        mov     [cs:DOSRegs._bx],bx     ; we can write into memory with
        mov     [cs:DOSRegs._cx],cx     ; CS prefics
        mov     [cs:DOSRegs._dx],dx     ;
        mov     [cs:DOSRegs._si],si     ;
        mov     [cs:DOSRegs._di],di     ;
        mov     [cs:DOSRegs._bp],bp     ;
        mov     [cs:DOSRegs._ds],ds     ;
        mov     [cs:DOSRegs._es],es     ;
        pushf                           ;
        pop     ax                      ;
        mov     [cs:DOSRegs._flags],ax  ;

        cli                             ; Interrupts will crash us
        mov     eax,cr0                 ;
        or      al,1                    ;
        mov     cr0,eax                 ;
;       jmp far sCode:goUp              ;
        db      0EAh                    ;
        dw      goUp                    ;
        dw      sCode                   ;
; Now we going upstairs
goUp:   mov     ax,sStack               ;
        mov     ss,ax                   ;
        mov     sp,[word ss:TSS0._esp]  ; Restore protected mode SP
        lidt    [fword ss:IDTreg]       ; Load protected mode IDT
        mov     ax,sPSP                 ; We have to load protected mode
        mov     ds,ax                   ; selectors in segment registers
        mov     ax,sData                ; before any interrupt can occure
        mov     es,ax                   ;
        sti                             ; Now we can enable interrupts
        mov     si,offset DOSRegs       ;
        mov     di,si                   ;
        mov     cx,10                   ; sizeof(DOSRegs)
        cld                             ;
        rep     movsw                   ;
        pop     es                      ;
        pop     ds                      ;
        popad                           ;
        ret                             ; Near return
        endp                            ;

;++ PROTECTED
; Return into real mode
; The procedure doesn't reload any segment registers.
; Entry:
;       none
; Return:
;       none
; Point all segment register to sData
;--

        proc    ReturnReal              ;

        mov     [ss:TSS0._eax],eax      ;
        pop     ax                      ; Pop the return address
        mov     [ss:TSS0.back],ax       ;

        cli                             ;
        push    bx                      ;
        push    dx                      ;
        mov     dl,[ss:slave]           ; Restore PICs
        mov     dh,[ss:master]          ;
        mov     bx,0870h                ;
        call    setupPIC                ;
        pop     dx                      ;
        pop     bx                      ;
                                        ;WARNING! These segment registers
                                        ;must be loaded by selector with
        mov     ax,sData                ;following characteristics:
        mov     ds,ax                   ; base  = doesn't matter
        mov     es,ax                   ; limit = 64k
        mov     fs,ax                   ; G     = 0 (byte granularity)
        mov     gs,ax                   ; E     = 0 (extended up)
        mov     ss,ax                   ; W     = 1 (write allowed)
                                        ; P     = 1 (segment present)
        mov     eax,[tmpCR0]            ; Enter real mode
        mov     cr0,eax                 ;

;       jmp far code:@@10               ; Flush prefetched queue
        db      0EAh                    ;
        dw      offset @@10             ;
realCS  dw      ?                       ;

@@10:   lidt    [fword cs:oldIDT]       ; Restore real mode IDTR
        mov     ax,[cs:realCS]          ;
        mov     ss,ax                   ;
        mov     sp,offset @STACK@       ;
        sti                             ; That's all right
        mov     eax,[TSS0._eax]         ; Notice that we don't reload DS so
        jmp     [word TSS0.back]        ; we can get EAX and return address
        endp                            ;

;++ REAL (V86)
; V86 entry point
;--

inV86:
;       cli
;       hlt
        lea     bx,[NonResident]
        shr     bx,4
        inc     bx
        mov     ax,4A00h
        cmp     [byte fname],0          ; Do we have to load file?
        jne     Load                    ; Yes - Shrink our MCB so we can get
        lea     dx,[restxt]             ; space to exec user program
        mov     ah,9                    ;
        int     21h                     ;
        push    bx
;        mov     ax,6200h                ;
;        int     21h                     ; get PSP addres
;        mov     [word psp_addres],bx    ;
        lea     di,[NonResident]
        xor     eax,eax
        mov     cx,-1
        sub     cx,di
        sub     cx,1024
        shr     cx,2
        rep     stosd                   ; 㫨 १  DG
        pop     bx
        mov     [byte 0001h],1          ; set flag (in PSP)
        mov     ax,3100h                ; Keep DG resident
        mov     dx,bx                   ;
Load:   int     21h
Reload: mov     ax,cs
        mov     ds,ax
        mov     es,ax
        mov     [byte exitflg],0
        mov     [word level],0
        lea     dx,[fname]
        lea     bx,[user]
        mov     ax,4B01h                ; Load but don't execute
        int     21h
        jnc     @@10
        lea     dx,[filtxt]
        mov     ah,9
        int     21h
        jmp     @@kk1
@@10:   cmp     [word user.sssp],0fffeh
        jae     @@k1
        add     [word user.sssp],2
@@k1:   mov     ah,62h
        int     21h
        mov     es,bx
        mov     [word es:TERM_IP],offset UserExit
        mov     [word es:TERM_CS],cs
        mov     cx,[word user.sssp]         ;sp
        mov     dx,[word (user.sssp)+2]     ;ss
        push    es ds bx dx cx 46h
        pop     es bx ds
        mov     ax,[es:0ch]
        mov     [word ptr bx-2],ax
        pop     bx ds es
        mov     si,[word user.csip]
        mov     di,[word (user.csip)+2]
;;;        cmp     di,dx
;;;        jne     @@kk1
;        cmp     cx,0fffeh
;        jae     @@kk1
;        or      cx,cx
;        je      @@kk1
;        add     cx,02
@@kk1:  mov     ax,0FF01h
        int     15h
        cli
        hlt

;++ REAL (V86)
; Emulate Exec (fn 4Bh, sfn 00h)
;--

UserExec:
        jc      @@Err
        mov     ah,62h
        int     21h
        mov     ds,bx
        mov     es,bx
        mov     [word TERM_IP],offset UserExit
        mov     [word TERM_CS],cs
;       cli
;       mov     ss,[word cs:(child.sssp)+2]
;       mov     sp,[word cs:child.sssp]
;       sti
;       xor     ax,ax
;       jmp     [dword cs:child.csip]
        mov     dx,[word cs:(child.sssp)+2]
        mov     cx,[word cs:child.sssp]
        mov     di,[word cs:(child.csip)+2]
        mov     si,[word cs:child.csip]
        mov     ax,0FF01h
        int     15h

@@Err:  dec     [word cs:level]
        stc                             ; Return error
        movzx   ebx,[word cs:level]
        jmp     [dword cs:retstk+ebx*4]

UserExit:
        dec     [word cs:level]
        jns     @@10
        cmp     [byte cs:exitflg],1
        je      RealExit
        ja      Reload
        mov     ah,4Dh
        int     21h
        mov     bx,ax
        mov     ax,0FF03h
        int     15h
@@10:   cmp     [byte cs:exitflg],1
        jb      @@20
        mov     ax,4C00h
        int     21h
@@20:   clc                             ; Return OK
        movzx   eax,[word cs:level]
        jmp     [dword cs:retstk+eax*4]

exitflg db      0                       ;
tmpCR0  dd      ?                       ;
_XMM_   dd      0
master  db      ?                       ;
slave   db      ?                       ;
oldIDT  dw      ?                       ; Limit and base of real mode IDT
        dd      ?
DOSRegs dos_regs <>                     ;
fpath   db      128 dup (0)
fname   db      128 dup (0)
user    epb     <>
child   epb     <>
filtxt  db      "Invalid filename$"
level   dw      0
retstk  dd      10 dup (0)              ;
;==================== The beginning of nonresident part =======================
NonResident:

oldvecs dd      256 dup (0)             ; Old interrupt vectors
IDTreg  dw      ?                       ; Limit and base of protected
        dd      ?                       ; mode IDT
base    dd      0                       ; DeGluckers base address
extsize dw      0                       ; Size of available extended memory

dgtxt   db      0dh,0ah,"DeGlucker v",Ver," (C) 1992-99 by Max Martynov AkA -=CrazyMaX=-", 0Dh, 0Ah
        db      "Originally by A.Ilyushin (ALI) & S.Gorokhov (MASTER)",0dh,0ah,"$"
comtxt  db      "Invalid command line$"
cputxt  db      "This program requires 386 or above processor$"
vgatxt  db      "This program requires VGA$"
v86txt  db      0dh,0ah,"Your PC already running in V86 mode (try run on clear machine)$"
memtxt  db      "Not enough extended memory to run the program (about 64K needed)$"
a20txt  db      "Can't enable A20$"
esttxt  db      "Can't establish DeGlucker anyway$"
restxt  db      "DeGlucker installed. Use Pause key to pop up.$"
notinst db      "DeGlucker isn't installed in memory$"
remtxt  db      "DeGlucker removed from memory$"
help_mess db    0dh,0ah," ͻ",0dh,0ah
          db            "  DeGlucker v",Ver," - nice and small debugger for DOS. Coded by -=CrazyMaX=- ",0dh,0ah
          db            "  Debug programs in V86 mode. Made for true hard-working hackers specially ! ",0dh,0ah
          db            " Ķ",0dh,0ah
          db            "  Usage:   DG.COM <program.ext>    (extension must be included)              ",0dh,0ah
          db            "  or       DG.COM -k <program.ext> (to full keyboard unlock mode)            ",0dh,0ah
          db            "  or       DG.COM -e <program.ext> (enable emulation of Exception N6)        ",0dh,0ah
          db            "  or       DG.COM                  (to stay resident. <Pause> key for popup) ",0dh,0ah
          db            "  or       DG.COM -r               (to remove from memory)                   ",0dh,0ah
          db            "  or       DG.COM -?               (to get this help)                        ",0dh,0ah
          db            " ͼ",0dh,0ah,0dh,0ah,"$"

;=================== GLOBAL DESCRIPTORS TABLE ==================

GDTbeg  desc    <>                      ; 00 Dummy
dPSP    desc    <0FFFFh,0,0,9Bh,0Fh,0>  ; 08 PSP
dCode   desc    <0FFFFh,0,0,9Bh,0Fh,0>  ; 10 CODE
dData   desc    <0FFFFh,0,0,93h,0Fh,0>  ; 28 DATA
dStack  desc    <0FFFFh,0,0,93h,0Fh,0>  ; 20 STACK
dVideo  desc    <7FFFh,8000h,0Bh,93h,0,0>;28 VIDEO
dGraph  desc    <0FFFFh,0,0Ah,93h,0,0>  ; 30 GRAPH
dTSS0   desc    <lTSS0,TSS0,0,89h,0,0>  ; 38 TSS level 0
dTSSdos desc    <>                      ; 40 TSS dos
dTSSv86 desc    <lv86,TSSv86,0,0EBh,0,0>; 48 TSS v86 (3 Busy)
dConv   desc    <0FFFFh,0,0,93h,0CFh,0> ; 50 Conventional memory (4 Gb)
dLDT0   desc    <7,0,0,82h,0,0>         ; 58 LDT level 0
dLDT3   desc    <7,0,0,0E2h,0,0>        ; 60 LDT level 3
dTSSv88 desc    <lv86,TSSv86,0,93h,0,0> ; 68 TSS v86 as data
dPSP93  desc    <0FFFFh,0,0,93h,0Fh,0>  ; 70 PSP as data
GDTlen  = $ - GDTbeg - 1                ;

;===================== TASK STATE SEGMENTS =====================

TSS0    tss     <sTSSv86>               ;
lTSS0   = $ - TSS0 - 1          ;
TSSv86  tss     <0,0,0FFFEh,sStack,0,\  ; Back, Stack0
                0FFFEh,sStack,0,\       ; Stack1
                0FFFEh,sStack,0,\       ; Stack2
                0,offset inV86,22202h,\ ; CR3, EIP, EFLAGS(V,IO=3,I)
                0,0,0,0,0,0,0,0,\       ; EAX,ECX,EDX,EBX,ESP,EBP,ESI,EDI
                0,0,0,0,0,0,0,0,0,0,0,0\; ES, CS, SS, DS, FS, GS
                sLDT3>                  ; LDTR
        dd      0
        dw      0
        dw      4090 dup (0)            ;
        db      0FFh                    ; End of the iomap
lv86    = $ - TSSv86 - 1                ;

;================= INTERRUPT DESCRIPTORS TABLE =================

IDTbeg: gate    <offset Exc0>           ;
        gate    <offset Exc1,sCode,0,8Fh>;
        gate    <offset Exc2>           ;
        gate    <offset Exc3>           ;
        gate    <offset Exc4>           ;
        gate    <offset Exc5>           ;
        gate    <offset Exc6>           ;
        gate    <offset Exc7>           ;
        gate    <offset Exc8>           ;
        gate    <offset Exc9>           ;
        gate    <offset Exc10>          ;
        gate    <offset Exc11>
        gate    <offset Exc12>
        gate    <offset Exc13>
        gate    <offset Exc14>
        gate    <offset Exc15>
        gate    <offset Exc16>

        rept    15
        gate    <offset Exc17_31>       ;
        endm                            ;

        rept    80
        gate    <offset Exc17_31>       ;
        endm

        gate    <offset IRQ0>           ;
        gate    <offset IRQ1>           ;
        gate    <offset IRQ2>           ;
        gate    <offset IRQ3>           ;
        gate    <offset IRQ4>           ;
        gate    <offset IRQ5>           ;
        gate    <offset IRQ6>           ;
        gate    <offset IRQ7>           ;
        gate    <offset IRQ8>           ;
        gate    <offset IRQ9>           ;
        gate    <offset IRQ10>          ;
        gate    <offset IRQ11>          ;
        gate    <offset IRQ12>          ;
        gate    <offset IRQ13>          ;
        gate    <offset IRQ14>          ;
        gate    <offset IRQ15>          ;

        rept    128
        gate    <offset Exc17_31>       ;
        endm                            ;

IDTlen  = $ - IDTbeg - 1                ;

;++ REAL
; Execution begins here
;--

InitLoader:                             ;

        mov     ah,9                    ; Tell Copyright
        lea     dx,[dgtxt]
        int     21h

        call    ComLine                 ;
        jc      TheEnd                  ;
        call    CPUcheck                ; Make sure that is 386
        jc      TheEnd                  ;
        call    VGAcheck                ;
        jc      TheEnd                  ;
        call    XMScheck                ; Allocate XMS
        jc      TheEnd

        push    es
        mov     ah,34h
        xor     ebx,ebx
        int     21h                     ; 䫠  

        xor     eax,eax
        mov     ax,es                   ;  䫠
        shl     eax,4                   ; 
        add     eax,ebx
        mov     [Dos_flag],eax

        cmp     [byte fname],0          ; Do we have to load file?
        je      rezid                   ; Yes - Shrink our MCB so we can get

        mov     ax,[016h]
        mov     [psp_save],ax
        mov     [016h],cs
rezid:
        push    es
        xor     ax,ax
        mov     es,ax
        mov     eax,[es:21h*4]          ;  (21 뢠)
        pop     es
        mov     [dos_adr],eax

        mov     ax,40h
        mov     es,ax
        mov     al,[byte es:BIOS_COL]   ; Get cursor position
        mov     [byte CUR_COL],al
        mov     al,[byte es:BIOS_ROW]
        mov     [byte CUR_ROW],al
        mov     al,[byte es:BIOS_WIDTH] ; Get screen dimensions
        mov     [byte MAX_COL],al       ;
        mov     al,[byte es:BIOS_HEIGHT];
        mov     [byte MAX_ROW],al       ; Warning! MAX_ROW = ScreenRows - 1
        pop     es                      ; while MAX_COL = ScreenColumns

        cli                             ;
        mov     sp, offset @STACK@      ; Move our stack down
        mov     [word TSSv86._esp],sp   ; Save SS:SP into v86 task state
        mov     [word TSSv86._ss],ss    ;
        sti

        call    SaveVectors             ;
        call    Builder                 ; Go into protected mode
        jmp     ReturnDOS               ; We can't return here

TheEnd: mov     ax,4C00h                ;
        int     21h                     ; Exit to DOS

;++
; Reset the user task
;--

Reset:  push    ds
        mov     ax,sPSP93

;++
; After many hours of hard thinking about it, I decide don't reset
; CPU at all. Instead I just return to real mode. That's all.
;--

HdwReset:
        mov     al,0FEh                 ;
        out     64h,al                  ;
        cli                             ;
        hlt                             ; Stand by while RESET

;++ REAL
; Parse command line.
; This procedure recognize the switch -r only.
;--
        proc    ComLine

        cld
        mov     si,81h
        mov     cl,[byte 80h]           ;
        xor     ch,ch                   ; Here I can't use movzx of 386
@@10:   lodsb
        jcxz    @@Ret2
        dec     cx
        cmp     al,' '
        je      @@10
        cmp     al,'/'
        je      @@switch
        cmp     al,'-'
        je      @@switch

        mov     [byte cs:trace],2       ; Popup when user task has been loaded
        cmp     [byte si],':'                ;஢ --  -  
        je      @@15
        push    si
        push    cx
        mov     ah,19h
        int     21h
        add     al,'A'
        mov     [byte fname],al
        mov     [word fname+1],'\:'
        mov     ah,47h
        mov     si,offset fname+3
        push    si
        mov     dl,0
        int     21h
        pop     di
        mov     bx,di
        mov     al,0
        mov     cl,0ffh
        repne   scasb                   ;ப 稢 㫥
        cmp     di,offset fname+4       ;஢ઠ    
        jne     @@pp1
        dec     di
@@pp1:  mov     [byte di-1],'\'
        sub     bx,di
        neg     bx
        add     bx,3                    ; 4   'a:\'
        pop     cx
        add     bl,cl
        pop     si
        cmp     bl,126
        ja      @@inv                   ;. ப 㬬୮ > 126 
        dec     si
        lodsb
        jmp     @@20

@@Ret2: ret

@@15:   lea     di,[fname]              ;
@@20:   stosb                           ;
        jcxz    @@30                    ;
        dec     cx                      ;
        lodsb                           ;
        cmp     al,' '                  ;
        jne     @@20
        xor     al,al
        stosb
        inc     cx
        sub     si,2
        jmp     @@35
@@30:   xor     al,al
        stosb
        sub     si,1
;        inc     cx
@@35:   mov     [byte si],cl            ; Prepare Lstring
        mov     [word user.comlin],si   ;
        mov     [word (user.comlin)+2],ds;
        clc
        jmp short @@Ret

@@inv:  lea     dx,[comtxt]             ; Tell that is invalid command
@@inv2: mov     ah,9                    ; line
        int     21h
        stc
        jmp short @@Err

@@switch:
        lodsb
        cmp     al,'r'
        je      @@sw1
        cmp     al,'?'                  ;᪠
        je      @@sw2
        cmp     al,'k'
        je      @@sw3
        cmp     al,'e'
        je      @@sw4
        cmp     al,'h'
        jne     @@inv
@@sw2:  mov     dx, offset help_mess
        jmp     @@inv2

@@sw3:  mov     [word cs:kbd_hrd],9090h ;  NOP` `JMP`
        dec     cx
        jmp     @@10


@@sw4:  mov     [word cs:emul_6],9090h ;  NOP` `JMP`
        dec     cx
        jmp     @@10

@@sw1:  call    ShutdownKernel          ;
        jc      @@Ret                   ;

        mov     ah,9                    ; Tell that kernel was shutdown
        lea     dx,[remtxt]
        int     21h
@@Err:  stc
@@Ret:  ret
        endp

;++ REAL
; Shutdown Kernel.
; Entry:
;       none
; Return:
;       NC      - if kernel shutdown is successfully completed
;       CY      - if signs of kernel activity was found
;--

        proc    ShutdownKernel          ;

        mov     [word TSSv86._esp],sp
        mov     [word TSSv86._ss],ss

        stc
        mov     ax,0FF00h
        int     15h                     ; Check the kernel activity
        jnc     @@20                    ; Jump if kernel installed

        lea     dx,[notinst]            ; Tell that is no kernel
        mov     ah,9                    ; resides in memory
        int     21h
        stc                             ; Set carry to indicate error
        jmp short @@Ret                 ;

@@20:   mov     ax,0FF02h               ; Call the kernel to shutdown
        int     15h
        cli
        mov     ax,cs                   ; Restore segment registers
        mov     ds,ax
        mov     es,ax
        mov     sp,[word TSSv86._esp]   ; Restore stack pointer
        mov     ss,[word TSSv86._ss]
        mov     al,000h                 ;
        out     21h,al                  ;
        mov     al,0B8h                 ;
        out     0A1h,al                 ; Enable IRQs: 0,1,2,3,4,6,8,9,10,14
        sti                             ;
@@Ret:  ret                             ;
        endp                            ;

;++ REAL
; CPU determination.
; Saves IDT register in the variable 'oldIDT'.
;--

        proc    CPUcheck

        lea     dx,[cputxt]
        push    sp                      ; 8086 saves sp after decrement
        pop     ax                      ;
        cmp     ax,sp                   ;
        jne     @@Bad                   ;

        sidt    [fword oldIDT]          ; Save contense of old IDTR
        cmp     [byte oldIDT+5],0FFh    ; Is it a 286 processor?
        je      @@Bad                   ; Jump if no

        smsw    ax                      ; Check for V86
        test    al,1
        clc
        je      @@Ret
        lea     dx,[v86txt]             ; in V86 already

@@Bad:  mov     ah,9
        int     21h
        stc
@@Ret:                                  ; CY - wrong processor
        ret                             ; NC - 386 processor
        endp

;++ REAL
; Check VGA adapter
;--
        proc    VGAcheck                ;

        mov     dx,3C8h                 ;
        mov     al,55h                  ;
        out     dx,al                   ;
        delay                           ;
        in      al,dx                   ;
        cmp     al,55h                  ;
        clc                             ;
        je      @@Ret                   ;
        lea     dx,[vgatxt]             ; non-VGA
        mov     ah,9                    ;
        int     21h                     ;
        stc                             ;
@@Ret:  ret                             ;
        endp                            ;

;++ REAL
; Extended memory allocation.
; Return:
;       CY      - if an error occured
;--

        proc    XMScheck

        call    XMM_Installed           ; Check for XMM presence
        jc      @@Int15                 ; If not present use Int 15h
        call    XMM_QueryA20            ;
        jnc     @@10                    ; If enabled jump over
        call    XMM_EnableA20           ;
        lea     dx,[a20txt]             ;
        jc      @@Err                   ;
@@10:   mov     dx,DBSIZE               ;
        call    XMM_Alloc               ; Allocate
        jc      @@ErrMem                ;
        mov     [deskr],dx
        call    XMM_Lock                ;
        jc      @@ErrMem                ;
        mov     [base],edx              ;
        jmp short @@ret                 ;
@@Int15:
        mov     ah,88h                  ;
        int     15h                     ;
        sub     ax,DBSIZE               ;
        jb      @@ErrMem                ;
        mov     [extsize],ax            ;
        mov     cx,1024                 ;
        mul     cx                      ;
        add     dx,10h                  ;
        mov     [word base],ax          ;
        mov     [word base+2],dx        ;
        call    IsA20On                 ; Check the state of the A20 line
        jnz     @@ret                   ;
        call    EnableA20               ;
        lea     dx,[a20txt]             ;
        jc      @@Err                   ;
        jmp short @@ret                 ;
@@ErrMem:
        lea     dx,[memtxt]             ;
@@Err:  mov     ah,09h                  ;
        int     21h                     ;

@@ret:  ret                             ;
        endp                            ;

;++ REAL
; Save the interrupt vectors table.
; Expect data segment in ES.
;--
        proc    SaveVectors

        cld
        push    ds
        xor     si,si
        mov     ds,si
        lea     di,[oldvecs]
        mov     cx,256
        rep     movsd
        pop     ds
        ret
        endp

;++ PROTECTED
; Restore the interrupt vectors table.
; Destroys DS and ES.
;--
        proc    RestoreVectors

        cld
        mov     si,sData
        mov     ds,si
        mov     si,sConv
        mov     es,si
        xor     di,di
        lea     si,[oldvecs]
        mov     cx,256
        rep     movsd
        ret
        endp

;++ REAL
; Set up PICs and set shutdown status byte to 0Ah.
; Build TSSes, GDT and IDT. Enter protected mode.
; Moves the monitor into extended memory.
; Expect data segment in ES.
; Destroys all general purpose registers and ES register.
;--

        proc    Builder

        mov     [word realCS],cs        ; Link fixup

; Build TSSv86

        xor     eax,eax
        mov     ax,cs
        mov     cx,6
        lea     di,[TSSv86._es]
        rep     stosd                   ; Set up segment registers

        cli

        call    savePIC                 ; Save PIC masks
        mov     bx,7078h                ; Master 70h, Slave 78h
;       mov     dx,0FFFFh               ; Disable all IRQs
;       mov     dx,0B8BCh               ; Enable IRQs: 0,1,2,6,8,9,14
        call    setupPIC                ;

        mov     ax,[word base]
        mov     dx,[word base+2]

        setAddr dCode                   ;
        setAddr dData                   ;
        setAddr dStack                  ;
        setAddr dTSS0                   ;
        setAddr dTSSv86                 ;
        setAddr dTSSv88                 ;

        add     ax,offset IDTbeg        ;
        adc     dx,0                    ;
        mov     [word IDTreg],IDTlen    ;
        mov     [word IDTreg+2],ax      ;
        mov     [word IDTreg+4],dx      ;
        lidt    [fword IDTreg]          ; LOAD IDTR

        mov     ax,cs                   ;
        mov     cx,10h                  ; Calculate linear address of CS
        mul     cx                      ;
        setAddr dPSP                    ;
        setAddr dPSP93                  ;

        add     ax,offset GDTbeg        ;
        adc     dx,0                    ;
        mov     [word GDTbeg],GDTlen    ;
        mov     [word GDTbeg+2],ax      ;
        mov     [word GDTbeg+4],dx      ;
        lgdt    [fword GDTbeg]          ;

        mov     eax,cr0                 ;
        mov     [tmpCR0],eax            ;
        or      al,1                    ;
        mov     cr0,eax                 ;

;       jmp far sPSP:inPmode
        db      0EAh                    ; Flush prefetched queue
        dw      offset inPmode          ; and load CS with correct
        dw      sPSP                    ; selector

inPmode:
        mov     ax,sData
        mov     es,ax
        mov     ax,sStack
        mov     ss,ax

        mov     ax,cs                   ;
        mov     ds,ax                   ;

        cld                             ;
        xor     si,si                   ;
        xor     di,di                   ;
        mov     cx,8000h                ;

        rep     movsw                   ;

        mov     ax,sData
        mov     ds,ax

        mov     ax,[word base]          ;
        mov     dx,[word base+2]        ;
        add     ax,offset GDTbeg        ;
        adc     dx,0                    ;
        mov     [word GDTbeg],GDTlen    ;
        mov     [word GDTbeg+2],ax      ;
        mov     [word GDTbeg+4],dx      ;
        lgdt    [fword GDTbeg]          ; LOAD GDTR

        mov     ax,sTSS0
        ltr     ax                      ; Set task register

        pushfd
        pop     eax                     ; Get Flags
        or      ah,40h                  ; Set NT bit
        push    eax
        popfd

;       call    DumpStack
;       call    Dump386Regs

;???
;       lea     bx, [ TSSv86 ]          ;
;       call    DumpTSS                 ;
;       ret
;???

        iret                            ; Go into V86 mode
        endp                            ;

;++ BOTH
; Setup Programmable Interrupt Controller
; Entry:
;       BH      - int number for master
;       BL      - int number for slave
;       DH      - mask for master
;       DL      - mask for slave
; Return:
;       none
; Destroy:
;       AL
;--

        proc    setupPIC                ; Now we put out 4-byte initialization
                                        ; sequence to master and slave PICs
        mov     al,11h                  ; ICW1 (request ICW4)
        out     20h,al                  ;
        delay                           ;
        out     0A0h,al                 ;
        delay                           ;
        mov     al,bh                   ; int num for master
        out     21h,al                  ;
        delay                           ;
        mov     al,bl                   ; int num for slave
        out     0A1h,al                 ;
        delay                           ;
        mov     al,4                    ; slave is connected to IRQ2
        out     21h,al                  ;
        delay                           ;
        mov     al,2                    ; master has a slave on IRQ2
        out     0A1h,al                 ;
        delay                           ;
        mov     al,1                    ; iAPX 86 mode
        out     21h,al                  ;
        delay                           ;
        out     0A1h,al                 ;
        delay                           ;
        mov     al,dh                   ; mask (disable) some channels
        out     21h,al                  ;
        delay                           ;
        mov     al,dl                   ;
        out     0A1h,al                 ;
        ret                             ;
        endp                            ;

;++ BOTH
; Save masks for PIC
; Expects:
;       DS - data segment
; Returns:
;       DH - master mask register
;       DL - slave mask register
;--

        proc    savePIC                 ;

        mov     al,0Ah                  ;
        out     20h,al                  ;
        delay                           ;
        in      al,21h                  ;
        mov     [master],al             ;
        mov     dh,al                   ;

        mov     al,0Ah                  ;
        out     0A0h,al                 ;
        delay                           ;
        in      al,0A1h                 ;
        mov     [slave],al              ;
        mov     dl,al                   ;

        ret                             ;
        endp                            ;

;++ BOTH
; Write to CMOS
; AL    - Register
; AH    - Value
;--

        proc    WriteCMOS               ;

        out     70h,al                  ;
        xchg    ah,al                   ;
        jmp     $+2                     ;
        jmp     $+2                     ;
        jmp     $+2                     ;
        out     71h,al                  ;
        xchg    ah,al                   ;
        ret                             ;

        endp                            ;

;++ NOT USED
; Fill in descriptor
;       DI    - descriptor to fill
;       DX:AX - 32-bit linear address
;       CX    - limit
;       BL    - access byte
;       BH    - four high bits of access rights and
;               four high bits of limit
; Return:
;       nothing
; Destroy:
;       DI
;--
        proc    FillDesc                ;

        add     di,offset GDTbeg        ;

        mov     [(desc di).limit],cx    ; Set LIMIT
        mov     [(desc di).access],bl   ; Access rights
        mov     [(desc di).baseL],ax    ; Base (0..15)
        mov     [(desc di).baseM],dl    ; Base (16..23)
        mov     [(desc di).acclim],bh   ; Access (4 bits) and limit(4 bits)
        mov     [(desc di).baseH],dh    ; Base (24..31)

        ret                             ;
        endp                            ;

ends
        end     Start
