;***************************************************************
;*               PROTECTED MODE KEYBOARD HANDLER               *
;*                                                             *
;*            Version 1.00          Revision: 4-Jan-93         *
;*                                                             *
;*                 Copyright (c) 1993 by AlI.                  *
;***************************************************************

Ideal                                   ;
NOSMART                                 ;
P386                                    ;

include "defines.inc"                   ;

        segment code word public use16 'CODE'
        assume  cs:code,ds:code

lastkey db      0                       ;
KBDflgs db      0
KBDbuf  db      20 dup(0)               ;
KBDend:
KBDhead dw      offset KBDbuf           ;
KBDtail dw      offset KBDbuf           ;

;++
; Keyboard traslation table
; The first byte is ASCII code in lower case or special code.
; The second byte is ASCII code in upper case or must be interpreted
; in accordance with special code.
; Allowed special codes is:     Meaning of the second byte:
;       0 - extended key                scancode
;       1 - shift key                   shift status
;       2 - lock key                    shift status
;       3 - keypad key                  ASCII code
;--

KBDscan db      0,0                     ; Dummy
        db      1Bh,1Bh                 ; 01
        db      '1','!'                 ; 02
        db      '2','@'                 ; 03
        db      '3','#'                 ; 04
        db      '4','$'                 ; 05
        db      '5','%'                 ; 06
        db      '6','^'                 ; 07
        db      '7','&'                 ; 08
        db      '8','*'                 ; 09
        db      '9','('                 ; 0A
        db      '0',')'                 ; 0B
        db      '-','_'                 ; 0C
        db      '=','+'                 ; 0D
        db      08h,08h                 ; 0E Backspace
        db      09h,09h                 ; 0F Tab
        db      'q','Q'                 ; 10
        db      'w','W'                 ; 11
        db      'e','E'                 ; 12
        db      'r','R'                 ; 13
        db      't','T'                 ; 14
        db      'y','Y'                 ; 15
        db      'u','U'                 ; 16
        db      'i','I'                 ; 17
        db      'o','O'                 ; 18
        db      'p','P'                 ; 19
        db      '[','{'                 ; 1A
        db      ']','}'                 ; 1B
        db      0Dh,0Dh                 ; 1C Enter
        db      01h,CTRL                ; 1D Ctrl
        db      'a','A'                 ; 1E
        db      's','S'                 ; 1F
        db      'd','D'                 ; 20
        db      'f','F'                 ; 21
        db      'g','G'                 ; 22
        db      'h','H'                 ; 23
        db      'j','J'                 ; 24
        db      'k','K'                 ; 25
        db      'l','L'                 ; 26
        db      ';',':'                 ; 27
        db      '''','"'                ; 28
        db      '`','~'                 ; 29
        db      01h,SHIFT               ; 2A Left Shift
        db      '\','|'                 ; 2B
        db      'z','Z'                 ; 2C
        db      'x','X'                 ; 2D
        db      'c','C'                 ; 2E
        db      'v','V'                 ; 2F
        db      'b','B'                 ; 30
        db      'n','N'                 ; 31
        db      'm','M'                 ; 32
        db      ',','<'                 ; 33
        db      '.','>'                 ; 34
        db      '/','?'                 ; 35
        db      01h,SHIFT               ; 36 Right Shift
        db      '*','*'                 ; 37
        db      01h,ALT                 ; 38 Alt
        db      ' ',' '                 ; 39 Spacebar
        db      02h,CAPS                ; 3A CapsLock
        db      00h,3Bh                 ; 3B F1
        db      00h,3Ch                 ; 3C F2
        db      00h,3Dh                 ; 3D F3
        db      00h,3Eh                 ; 3E F4
        db      00h,3Fh                 ; 3F F5
        db      00h,40h                 ; 40 F6
        db      00h,41h                 ; 41 F7
        db      00h,42h                 ; 42 F8
        db      00h,43h                 ; 43 F9
        db      00h,44h                 ; 44 F10
        db      02h,NUM                 ; 45 Num Lock
        db      02h,SCROLL              ; 46 Scroll Lock
        db      03h,'7'                 ; 47 Home
        db      03h,'8'                 ; 48 Up
        db      03h,'9'                 ; 49 PgUp
        db      00h,4Ah                 ; 4A Grey '-'
        db      03h,'4'                 ; 4B Left
        db      03h,'5'                 ; 4C Keypad '5'
        db      03h,'6'                 ; 4D Right
        db      00h,4Eh                 ; 4E Grey '+'
        db      03h,'1'                 ; 4F End
        db      03h,'2'                 ; 50 Down
        db      03h,'3'                 ; 51 PgDn
        db      03h,'0'                 ; 52 Ins
        db      03h,'.'                 ; 53 Del
        db      00h,54h                 ; 54 SysRq
        db      00h,55h                 ; 55 I don't know
        db      00h,56h                 ; 56 I don't know
        db      00h,57h                 ; 57 F11
        db      00h,58h                 ; 58 F12
KBDmax  = ($-KBDscan)/2

;++
; Keyboard interrupt handler
; If you want shift key to work properly don't press both shift keys
; simultaneosly.
;--

IRQ1:   push    ax
        in      al,60h
        cmp     al, 45h                 ;
        jne     @@01                    ;
        cmp     [ byte ss:lastkey ], 1Dh;
        jne     @@00                    ;
        call    EatKey                  ;
        pop     ax                      ;
        iretd                           ;
@@01:
        cmp     al,0C5h                 ; Num Lock released?
        jne     @@00
        cmp     [byte ss:lastkey],9Dh   ; Ctrl released?
        jnz     @@00                    ;
        push    bp                      ;
        mov     bp,sp                   ;
        test    [byte bp+14],2          ; Test VM
        pop     bp                      ;
        jz      @@00                    ;

        call    EatKey                  ;
        pop     ax                      ;
        push    0
        call    Master
        iretd

@@00:   mov     [byte ss:lastkey],al    ;
        pop     ax                      ;
        push    9                       ; Push vector
        call    INTn                    ;
        push    ax                      ;
        push    bx
        push    ds
        push    si
        mov     ax,sData                ;
        mov     ds,ax                   ; Load Data Descriptor

        in      al,60h                  ; Get scan code

;       lea     si,[IRQ1txt]
;       call    PrintStr
;       call    PrintAX
;       call    NewLine

        test    al,80h                  ; Branch if it's break code
        jnz     @@Break                 ;

        mov     bl,al                   ;
        xor     bh,bh                   ;
        shl     bx,1                    ;
        mov     ah,al                   ;
        mov     al,[byte KBDscan+bx]    ; Translate make code into
        cmp     al,1                    ; internal code
        jb      @@Ext                   ;
        je      @@Shift                 ;
        cmp     al,3                    ;
        jb      @@Lock                  ;
        je      @@Keypad                ;

        test    [byte KBDflgs],ALT or CTRL; Does Alt or Ctrl key pressed?
        jnz     @@Ctrl                  ; Jump if yes

        test    [byte KBDflgs],SHIFT    ;
        jz      @@10                    ;
        cmp     al,' '                  ; Is it a control code?
        jb      @@Ctrl                  ; If so jump

        xor     bl,1                    ; Shift

@@10:   cmp     al,'z'                  ; If it's a letter we must also
        ja      @@20                    ; check for CAPS LOCK
        cmp     al,'a'                  ;
        jb      @@20                    ;

        test    [byte KBDflgs],CAPS     ;
        jz      @@20                    ;
@@15:   xor     bl,1                    ; Caps

@@20:   mov     al,[byte KBDscan+bx]    ; Finally we have correct letter
        xor     ah,ah                   ; Clear flags
        jmp short @@Put                 ;

@@Ctrl: cmp     al,'z'                  ; If it's a letter we must also
        ja      @@25                    ; convert it to upper case
        cmp     al,'a'                  ;
        jb      @@25                    ;
        and     al,0DFh                 ; Convert to upper casee
@@25:   mov     ah,[byte KBDflgs]       ;
        jmp short @@Put

@@Ext:  mov     al,ah                   ; Place scan code in AL
        mov     ah,[byte KBDflgs]       ; Make the flags
        or      ah,EXT                  ; Set EXTended key bit

@@Put:  shr     ah,4                    ; Normalize flags
        mov     bx,[KBDtail]            ; Now we have flags in AH
        mov     [bx],ax                 ; and ASCII or scan code in AL
        inc     bx                      ;
        inc     bx                      ;
        cmp     bx,[KBDhead]            ;
;       je      @@Overflow              ; !!! WARNING !!!
        je      @@Ret                   ;
        cmp     bx,offset KBDend        ;
        jb      @@30                    ;
        mov     bx,offset KBDbuf        ; Return to the begining of buffer
@@30:   mov     [KBDtail],bx            ;
        jmp short @@Ret                 ;

@@Keypad:                               ;
        test    [byte KBDflgs],EXT      ; Is it a grey key?
        jnz     @@33                    ; Make it EXT in any case
        test    [byte KBDflgs],NUM      ;
        jnz     @@15                    ; Branch if NUM LOCKed
@@33:   xor     al,al                   ;
        jmp short @@Ext                 ;

@@Lock:
        test    [byte KBDflgs],0F0h     ;
        jnz     @@Ret                   ;
        mov     al,0EDh                 ; Synhronize LED indicators
        out     60h,al                  ; with keyboard flags
        mov     al,[byte KBDscan+bx+1]  ;
        xor     [byte KBDflgs],al       ;
        mov     bx,02000h
@@35:   dec     bx                      ; Wait for keyboard
        jne     @@35                    ;
        mov     al,[KBDflgs]            ;
        and     al,07h                  ;
        out     60h,al                  ;
        jmp short @@Ret                 ;

@@Break:                                ;
        cmp     al,0E0h                 ;
        jne     @@37                    ;
        or      [byte KBDflgs],EXT      ;
        jmp short @@RetE                ;

@@37:   mov     ah,al                   ;
        shl     al,1                    ;
        mov     bl,al                   ;
        xor     bh,bh                   ;
        mov     al,[byte KBDscan+bx]    ;
        cmp     al,1                    ; Is it a shift key?
        jne     @@Ret                   ; Branch if no

@@Shift:                                ;
        mov     al,[byte KBDscan+bx+1]  ;
        test    al,SHIFT                ;
        jz      @@39                    ;
        test    [byte KBDflgs],EXT      ;
        jnz     @@Ret                   ;
@@39:   test    ah,80h                  ; Is it a make code or a break code?
        jz      @@40                    ;
        xor     al,0FFh                 ;
        and     [byte KBDflgs],al       ;
        jmp short @@Ret                 ;

@@40:   or      [byte KBDflgs],al       ;

@@Ret:  and     [byte KBDflgs],NOT EXT  ;
@@RetE: pop     si                      ;
        pop     ds                      ;
        pop     bx

        call    EatKey                  ;
        pop     ax                      ;
        iretd                           ;

;++
; Get a keystoke.
; Entry:
;       none
; Return:
;       AL      - ASCII or Scan code if an extended key pressed
;       AH      - Flags
;--

        proc    getkey

        push    ds
        push    bx

        mov     ax,sData                ;
        mov     ds,ax                   ;

@@10:   mov     bx,[KBDhead]            ;
        cmp     bx,[KBDtail]            ;
        je      @@10                    ;

        mov     ax,[bx]                 ;
        inc     bx                      ;
        inc     bx                      ;
        cmp     bx,offset KBDend        ;
        jb      @@20                    ;
        mov     bx,offset KBDbuf        ;
@@20:   mov     [KBDhead],bx            ;

        pop     bx
        pop     ds
        ret                             ;
        endp                            ;

;++
; Check for keystoke.
; Entry:
;       none
; Return:
;       ZY      - if no keystroke available
;       NZ      - if a keystroke present
;--

        proc    kbhit

        push    ds
        push    ax

        mov     ax,sData                ;
        mov     ds,ax                   ;

@@10:   mov     ax,[KBDhead]            ;
        cmp     ax,[KBDtail]            ;

        pop     ax
        pop     ds
        ret                             ;
        endp                            ;

;++
; Check for keystoke.
; Entry:
;       none
; Return:
;       ZY      - if no keystroke available
;       NZ      - if a keystroke present
;       ᫨   -- AL=᪠, AH=䫠
;--

        proc    fn_01

        push    ds ax

        mov     ax,sData                ;
        mov     ds,ax                   ;

@@10:   mov     ax,[KBDhead]            ;
        cmp     ax,[KBDtail]            ;
        pop     ax
        je      @@20
        push    bx
        mov     bx,[KBDhead]
        mov     ax,[bx]
        pop     bx
@@20:   pop     ds
        ret                             ;
        endp                            ;

;++
;--
        proc    EatKey                  ;

        in      al,61h                  ;
        delay                           ;
        mov     ah,al                   ;
        or      al,80h                  ;
        out     61h,al                  ; Enable keyboard
        delay                           ;
        xchg    al,ah                   ;
        out     61h,al                  ;
        delay                           ;

        mov     al,20h                  ; End-Of-Interrupt
        out     20h,al                  ;
        ret                             ;

        endp                            ;
ends                                    ;

        end
