Ideal
p386                                    ;
global SavePlanes       : proc
global RestorePlanes    : proc
global SaveMode         : proc
global SetMode          : proc

        include "defines.inc"
;Ŀ
; Sequencer registers                           05h bytes +00h
; CRT controller registers                      1Ah bytes +05h
; Attribute controller registers                15h bytes +1Fh
; Graphics controller registers                 0Ah bytes +34h
; DAC registers                                 30h bytes +3Eh
; Feature register                              01h byte  +6Eh
; Miscellaneous                                 01h byte  +6Fh
; PEL mask                                      01h byte  +70h
;
macro delay                             ;
        call    dummy                   ;
endm                                    ;

        segment code byte public use16 'CODE'
        assume  cs:code, ds:code        ;

;***************************************;
; ds:di - place for saved data

SavePlanes:                             ;
        cld                             ;
        push    ds                      ;
        push    es                      ;
        push    ds                      ;
        pop     es                      ; es:di - data
        mov     ax, sGraph              ;
        mov     ds, ax                  ;
        xor     si, si                  ; ds:si - screen
        mov     bx, 0402h               ; 2nd plan (font)
        call    setregs                 ;
        push    di                      ;
        mov     di, offset font         ;
        mov     bx, 256                 ;
@@10:                                   ;
        mov     cx, 16                  ;
@@20:                                   ;
        mov     al, [ byte es:di ]      ;
        xchg    al, [ byte ds:si ]      ;
        mov     [ byte es:di ], al      ;
        inc     si                      ;
        inc     di                      ;
        loop    @@20                    ;
        add     si, 16                  ;
        dec     bx                      ;
        jnz     @@10                    ;
        pop     di                      ;

        mov     bx, 0100h               ;
        call    setregs                 ;
        xor     si, si                  ;
        mov     cx, 90*30               ;
@@30:                                   ;
        lodsb                           ;
        inc     si                      ;
        stosb                           ;
        loop    @@30                    ;

        mov     bx, 0201h               ;
        call    setregs                 ;
        xor     si, si                  ;
        mov     cx, 90*30               ;
@@40:                                   ;
        lodsb                           ;
        inc     si                      ;
        stosb                           ;
        loop    @@40                    ;

        pop     es                      ;
        pop     ds                      ;
        ret                             ;
;***************************************;
; ds:di - pointer to saved data         ;
                                        ;
RestorePlanes:                          ;
        cld                             ;
        push    ds                      ;
        push    es                      ;
        push    ds                      ;
        pop     es                      ; es:di - data
        mov     ax, sGraph              ;
        mov     ds, ax                  ;
        xor     si, si                  ; ds:si - screen
        mov     bx, 0402h               ; 2nd plan (font)
        call    setregs                 ;
        push    di                      ;
        mov     di, offset font         ;
        mov     bx, 256                 ;
@@10:                                   ;
        mov     cx, 16                  ;
@@20:                                   ;
        mov     al, [ byte es:di ]      ;
        xchg    al, [ byte ds:si ]      ;
        mov     [ byte es:di ], al      ;
        inc     si                      ;
        inc     di                      ;
        loop    @@20                    ;
        add     si, 16                  ;
        dec     bx                      ;
        jnz     @@10                    ;
        pop     si                      ;

        mov     ax, ds                  ;
        push    es                      ;
        pop     ds                      ;
        mov     es, ax                  ;

        mov     bx, 0100h               ;
        call    setregs                 ;
        xor     di, di                  ;
        mov     cx, 90*30               ;
@@30:                                   ;
        lodsb                           ;
        stosb                           ;
        inc     di                      ;
        loop    @@30                    ;

        mov     bx, 0201h               ;
        call    setregs                 ;
        xor     di, di                  ;
        mov     cx, 90*30               ;
@@40:                                   ;
        lodsb                           ;
        stosb                           ;
        inc     di                      ;
        loop    @@40                    ;

        pop     es                      ;
        pop     ds                      ;
        ret                             ;
;---------------------------------------;
setregs:                                ;
        mov     dx, 03C4h               ;
        mov     al, 02h                 ; map enable
        mov     ah, bh                  ;
        out     dx, ax                  ;
        delay                           ;
        mov     ax, 0704h               ;
        out     dx, ax                  ;
        delay                           ;
        mov     al, 01h                 ;
        out     dx, al                  ;
        delay                           ;
        inc     dx                      ;
        in      al, dx                  ;
        delay                           ;
        or      al, 20h                 ;
        out     dx, al                  ;
        delay                           ;

        mov     dx, 03CEh               ;
        mov     al, 04h                 ;
        mov     ah, bl                  ; plan to read
        out     dx, ax                  ;
        delay                           ;
        mov     ax, 0005h               ;
        out     dx, ax                  ;
        delay                           ;
        mov     ax, 0406h               ;
        out     dx, ax                  ;
        delay                           ;
        mov     ax, 0001h               ;
        out     dx, ax                  ;
        delay                           ;
        mov     ax, 0003h               ;
        out     dx, ax                  ;
        delay                           ;
        mov     ax, 0FF08h              ;
        out     dx, ax                  ;
        ret                             ;
;***************************************;
; es:di - buffer for saved data
SaveMode:                               ;
        cld                             ;
        mov     dx, 03CCh               ;
        in      al, dx                  ;
        delay                           ;
        mov     [ byte es:di+6Fh ], al  ; miscellaneous
        or      al, 1                   ;
        mov     dx, 03C2h               ;
        out     dx, al                  ; set new it
        delay                           ;
                                        ;
        mov     dx, 03DAh
@@90:
        in      al, dx
        test    al, 00001000b
        jnz      @@90
@@91:
        in      al, dx
;        test    al, 00000001b           ;max
        test    al, 00001000b
        jz     @@91

        mov     dx, 03C4h               ; sequencer
        mov     cx, 4                   ;
        mov     ah, 01                  ;
        in      al, dx                  ;
        stosb                           ; save (3C4)
@@10:                                   ;
        mov     al, ah                  ;
        out     dx, al                  ;
        delay                           ;
        inc     dx                      ;
        inc     ah                      ;
        in      al, dx                  ;
        dec     dx                      ;
        stosb                           ;
        loop    @@10                    ;
                                        ;
        mov     dx, 03D4h               ; CRT controller
        mov     cx, 19h                 ;
        mov     ah, 00                  ;
        in      al, dx                  ;
        stosb                           ; save (3D4)
@@20:                                   ;
        mov     al, ah                  ;
        out     dx, al                  ;
        delay                           ;
        inc     dx                      ;
        inc     ah                      ;
        in      al, dx                  ;
        dec     dx                      ;
        stosb                           ;
        loop    @@20                    ;
                                        ;
        mov     dx, 03C0h               ; attribute controller
        mov     cx, 15h                 ;
        mov     ah, 00                  ;
@@30:                                   ;
        push    dx                      ;
        mov     dx, 03DAh               ;
        in      al, dx                  ; clear flip/flop
        pop     dx                      ;
        mov     al, ah                  ;
        out     dx, al                  ;
        delay                           ;
        inc     dx                      ;
        inc     ah                      ;
        in      al, dx                  ;
        dec     dx                      ;
        stosb                           ;
        loop    @@30                    ;
        mov     dx, 03DAh               ;
        in      al, dx                  ; clear flip/flop
        delay                           ;
        mov     dx, 03C0h               ;
        mov     al, 20h                 ;
        out     dx, al                  ;
        delay                           ;
                                        ;
        mov     dx, 03CEh               ; graphics controller
        mov     cx, 09h                 ;
        mov     ah, 00                  ;
        in      al, dx                  ;
        stosb                           ; save (3CE)
@@40:                                   ;
        mov     al, ah                  ;
        out     dx, al                  ;
        delay                           ;
        inc     dx                      ;
        inc     ah                      ;
        in      al, dx                  ;
        dec     dx                      ;
        stosb                           ;
        loop    @@40                    ;
                                        ;
        mov     dx, 03C7h               ; DAC
        mov     cx, 10h                 ;
        mov     ah, 00                  ;
@@50:                                   ;
        mov     al, ah                  ;
        out     dx, al                  ;
        delay                           ;
        inc     dx                      ;
        inc     dx                      ;
        insb                            ;
        insb                            ;
        insb                            ;
        dec     dx                      ;
        dec     dx                      ;
        inc     ah                      ;
        loop    @@50                    ;
                                        ;
        mov     dx, 03CAh               ; feature register
        in      al, dx                  ;
        stosb                           ;
                                        ;
        inc     di                      ;!!! PEL mask
        mov     dx,03c6h                ;
        in      al,dx                   ;
        stosb                           ;
                                        ;
        ret                             ;
;***************************************;
; ds:si  ->
SetMode:                                ;
        cld                             ;
        mov     dx,03CCh                ;
        in      al,dx                   ;
        delay                           ;
        or      al,1                    ; miscellaneous ( 3D? )
        mov     dx,03C2h                ;
        out     dx,al                   ;
        delay                           ;
;---------------------------------------;
        mov     dx, 03DAh               ;max
@@90l:
        in      al, dx
        test    al, 00001000b
        jnz      @@90l
@@91l:
        in      al, dx
        test    al, 00001000b
        jz     @@91l
;---------------------------------------;

        mov     dx,03DAh                ;
        in      al,dx                   ; clear flip/flop
        delay                           ;
        xor     al,al                   ;
        mov     dx,03C0h                ;
        out     dx,al                   ; disable screen
        delay                           ;
;---------------------------------------;
        cli                             ; disable interrupts
        lodsb                           ;
        push    ax                      ;
        mov     ax,0100h                ;
        mov     dx,03C4h                ;
        out     dx, ax                  ; sequencer synchronous reset
        delay                           ;
        mov     cx, 4                   ;
@@10:   inc     al                      ; sequencer registers (1-4)
        mov     ah, al                  ;
        lodsb                           ;
        xchg    al, ah                  ;
        out     dx, ax                  ;
        loop    @@10                    ;
        pop     ax                      ;
        out     dx, al                  ; set (3C4)
;---------------------------------------;
        mov     ax,0300h                ;
        mov     dx,03C4h                ;
        out     dx,ax                   ; enable sequencer
        delay                           ;
        sti                             ; enable interrupts
;---------------------------------------;
        lodsb                           ;
        push    ax                      ;
        mov     dx,03D4h                ;
        mov     ax,0011h                ;
        out     dx,ax                   ; enable write to CRT controller
        delay                           ;
        mov     cx,19h                  ;
        xor     ax,ax                   ;
@@30:                                   ; CRT controller registers
        mov     ah,al                   ;
        lodsb                           ;
        xchg    al,ah                   ;
        out     dx,ax                   ;
        inc     al                      ;
        loop    @@30                    ;
        pop     ax                      ;
        out     dx, al                  ; set (3D4)
;---------------------------------------;
        mov     dx,03DAh                ;
        in      al,dx                   ; clear flip/flop
        xor     ax,ax                   ;
        mov     cx,15h                  ;
        mov     dx,03C0h                ;
@@40:                                   ; attribute controller registers
        mov     al,ah                   ;
        out     dx,al                   ; register number
        delay                           ;
        inc     ah                      ;
        lodsb                           ;
        out     dx,al                   ; register data
        delay                           ;
        loop    @@40                    ;
;---------------------------------------;
        xor     ax,ax                   ;
        mov     dx,03CCh                ;
        out     dx,al                   ; (03CC) <- 00
        delay                           ;
        inc     al                      ;
        mov     dx,03CAh                ;
        out     dx,al                   ; (03CA) <- 01
        delay                           ;
;---------------------------------------;
        lodsb                           ;
        push    ax                      ;
        mov     dx,03CEh                ;
        xor     ax,ax                   ;
        mov     cx, 9                   ;
@@70:                                   ; graphics controller registers
        mov     ah,al                   ;
        lodsb                           ;
        xchg    al,ah                   ;
        out     dx,ax                   ;
        inc     al                      ;
        loop    @@70                    ;
        pop     ax                      ;
        out     dx, al                  ; set (3CE)
;---------------------------------------;
        mov     dx,03C8h                ;
        xor     ax,ax                   ;
        mov     cx, 3*10h               ;
        out     dx, al                  ;
        delay                           ;
        inc     dx                      ;
@@80:                                   ; DAC registers
        outsb                           ; RGB
        loop    @@80                    ;
;---------------------------------------;
        lodsb                           ; feature register
        mov     dx,03DAh                ;
        out     dx,al                   ;
        delay                           ;
;---------------------------------------;
        lodsb                           ; miscellaneous
        mov     dx,03C2h                ;
        out     dx,al                   ;
        delay                           ;
;---------------------------------------;
        lodsb                           ; PEL mask
        mov     dx,03C6h                ;
        out     dx,al                   ;
        delay                           ;
;---------------------------------------;
exit:                                   ;
        mov     dx,03DAh                ;
        in      al,dx                   ;
        mov     dx,3C0h                 ;
        mov     al,20h                  ;
        out     dx,al                   ; enable screen
        ret                             ;
;---------------------------------------;
dummy:                                  ;
        ret                             ;
;---------------------------------------;
font:
        include 'font.inc'              ;
ends
        end
