;***************************************************************
;* XMM Interface Module 				       *
;* Programmed by ALI					       *
;* Version 0.1			      Last revision: 20-Aug-93 *
;***************************************************************

;--------------------------- History ---------------------------
; Ver	Date	   Who	   Description
; 0.1	20-Feb-93  AlI	   Written
; 0.11	23-Aug-93  ALI	   Fixed ES corruption in function
;			   XMM_Installed

Ideal					;
NOSMART
P386					;

include "defines.inc"			;
include "xmm.inc"			;

extrn	_XMM_	: dword

	segment code word public use16 'CODE'
	assume	cs:code,ds:code

	macro	SyncC
	shr	ax,1
	cmc
	setnc	al
	endm

;_XMM_	 dd	 0

;++
; Check state of XMM and get it entry point
; Returns:
;  CY	- if XMM not present, NC otherwise
;--
	Proc	XMM_Installed

	push	es
	mov	ax, 4300h		; Test for XMM
	int	2Fh
	cmp	al, 80h
	jne	@@No

	mov	ax, 4310h		; Get Control Function
	int	2Fh
	mov	[word cs:_XMM_], bx	;
	mov	[word cs:_XMM_+2], es	;
	clc				;
	jmp short @@Ret 		;
@@No:	stc				;
@@Ret:	pop	es
	ret
	endp

;++
; Call HMM through entry point
;--
	proc	XMM
	cmp	[word _XMM_+2],0
	je	@@Err
	call	[cs:_XMM_]
@@Ret:	ret
@@Err:	mov	ax,0
	stc
	ret
	endp

;++
; Get XMS Driver Version
;--
	Proc	XMM_Version
	xor	ah, ah				; Function 0
	call	XMM
	mov	dx, bx				; Return a long
	ret
	endp

;++
; Enable A20 gate
; Returns:
;  AX	- 1 if A20 enabled, 0 otherwise
;  BL	- error code
;--
	Proc	XMM_EnableA20
	mov	ah, 5
	call	XMM
	SyncC
	ret
	endp

;++
; Disable A20 gate
; Returns:
;  AX	- 1 if A20 enabled, 0 otherwise
;  BL	- error code
;--
	Proc	XMM_DisableA20
	mov	ah, 6
	call	XMM
	SyncC
	ret
	endp

;++
; Query A20 gate
; Returns:
;  AX	- 1 if A20 enabled, 0 otherwise
;  BL	- error code
;--
	Proc	XMM_QueryA20
	mov	ah, 7
	call	XMM
	SyncC
	ret
	endp

;++
; Allocate Extended Memory Block
; Expects:
;  DX	- size in KB
; Returns:
;  AX	- 1 on success, 0 otherwise
;  DX	- handle of memory block
;--
	proc	XMM_Alloc
	mov	ah, 9
	call	XMM
	SyncC
	ret
	endp

;++
; Free Extended Memory Block
; Expects:
;  DX	- handle
; Returns:
;  AX	- 1 on success, 0 otherwise
;--
	proc	XMM_Free
	mov	ah, 0Ah
	call	XMM
	SyncC
	ret
	endp

;++
; Lock Extended Memory Block
; Expects:
;  DX	- handle
; Returns:
;  AX	- 1 on success, 0 otherwise
;--
	proc	XMM_Lock
	mov	ah, 0Ch
	call	XMM
	shl	edx,16
	mov	dx,bx
	SyncC
	ret
	endp

;++
; Unlock Extended Memory Block
; Expects:
;  DX	- handle
; Returns:
;  AX	- 1 on success, 0 otherwise
;--
	proc	XMM_Unlock
	mov	ah, 0Dh
	call	XMM
	SyncC
	ret
	endp
ends
	end
